Index: /XIOS/trunk/src/node/grid.cpp
===================================================================
--- /XIOS/trunk/src/node/grid.cpp	(revision 886)
+++ /XIOS/trunk/src/node/grid.cpp	(revision 887)
@@ -26,5 +26,7 @@
       : CObjectTemplate<CGrid>(), CGridAttributes()
       , isChecked(false), isDomainAxisChecked(false)
-      , vDomainGroup_(), vAxisGroup_(), axisList_(), isAxisListSet(false), isDomListSet(false)
+      , vDomainGroup_(), domList_(), isDomListSet(false)
+      , vAxisGroup_(), axisList_(), isAxisListSet(false)
+      , vScalarGroup_(), scalarList_(), isScalarListSet(false)
       , clientDistribution_(0), isIndexSent(false) , serverDistribution_(0), clientServerMap_(0)
       , writtenDataSize_(0), numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
@@ -36,4 +38,5 @@
      setVirtualDomainGroup();
      setVirtualAxisGroup();
+     setVirtualScalarGroup();
    }
 
@@ -41,5 +44,7 @@
       : CObjectTemplate<CGrid>(id), CGridAttributes()
       , isChecked(false), isDomainAxisChecked(false)
-      , vDomainGroup_(), vAxisGroup_(), axisList_(), isAxisListSet(false), isDomListSet(false)
+      , vDomainGroup_(), domList_(), isDomListSet(false)
+      , vAxisGroup_(), axisList_(), isAxisListSet(false)
+      , vScalarGroup_(), scalarList_(), isScalarListSet(false)
       , clientDistribution_(0), isIndexSent(false) , serverDistribution_(0), clientServerMap_(0)
       , writtenDataSize_(0), numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
@@ -51,4 +56,5 @@
      setVirtualDomainGroup();
      setVirtualAxisGroup();
+     setVirtualScalarGroup();
    }
 
@@ -201,7 +207,8 @@
      if (this->isDomainAxisChecked) return;
 
+     this->solveScalarRef(areAttributesChecked);
      this->solveAxisRef(areAttributesChecked);
      this->solveDomainRef(areAttributesChecked);
-     computeGridGlobalDimension(getDomains(), getAxis(), axis_domain_order);
+     computeGridGlobalDimension(getDomains(), getAxis(), getScalars(), axis_domain_order);
      this->isDomainAxisChecked = areAttributesChecked;
    }
@@ -210,4 +217,11 @@
    {
      if (this->hasDomainAxisBaseRef_) return;
+     // Account for the scalar attributes
+     std::vector<CScalar*> scalarList = getScalars();
+     for (size_t i = 0; i < scalarList.size(); ++i)
+     {
+       scalarList[i]->setAttributesReference();
+     }
+
      // Account for the axis attributes
      std::vector<CAxis*> axisList = getAxis();
@@ -223,4 +237,5 @@
        domList[i]->setAttributesReference();
      }
+
      this->hasDomainAxisBaseRef_ = true;
    }
@@ -383,10 +398,11 @@
         for (int i = 0; i < axis_domain_order.numElements(); ++i)
         {
-          if (false == axis_domain_order(i))
+          int elementDimension = axis_domain_order(i);
+          if (1 == elementDimension)
           {
             axisPositionInGrid_.push_back(idx);
             ++idx;
           }
-          else idx += 2;
+          else if (2 == elementDimension) idx += 2;
         }
 
@@ -397,5 +413,21 @@
           else
             axisListP[i]->checkAttributesOnClient();
-          ++idx;
+        }
+      }
+   }
+
+   //---------------------------------------------------------------
+
+   void CGrid::solveScalarRef(bool sendAtt)
+   {
+      setScalarList();
+      std::vector<CScalar*> scalarListP = this->getScalars();
+      if (!scalarListP.empty())
+      {
+        for (int i = 0; i < scalarListP.size(); ++i)
+        {
+          /*Nothing to do for now */
+//          if (sendAtt) scalarListP[i]->sendCheckedAttributes();
+//          else scalarListP[i]->checkAttributesOnClient();
         }
       }
@@ -502,5 +534,5 @@
      int nbElement = axis_domain_order.numElements();
      std::vector<CArray<size_t,1> > globalIndexElement(nbElement);
-     int domainIdx = 0, axisIdx = 0;
+     int domainIdx = 0, axisIdx = 0, scalarIdx = 0;
      std::vector<size_t> elementNGlobal(nbElement);
      elementNGlobal[0] = 1;
@@ -511,5 +543,5 @@
        size_t elementSize;
        size_t elementGlobalSize = 1;
-       if (axis_domain_order(idx))
+       if (2 == axis_domain_order(idx))
        {
          elementSize = domList[domainIdx]->i_index.numElements();
@@ -522,5 +554,5 @@
          ++domainIdx;
        }
-       else
+       else if (1 == axis_domain_order(idx))
        {
          elementSize = axisList[axisIdx]->index.numElements();
@@ -532,4 +564,10 @@
          elementGlobalSize = axisList[axisIdx]->n_glo.getValue();
          ++axisIdx;
+       }
+       else
+       {
+         globalIndexElement[idx].resize(1);
+         globalIndexElement[idx](0) = 0;
+         elementGlobalSize = 1;
        }
        globalSize *= elementGlobalSize;
@@ -657,13 +695,54 @@
 
    CGrid* CGrid::createGrid(const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
-                            const CArray<bool,1>& axisDomainOrder)
-   {
-      return createGrid(generateId(domains, axis, axisDomainOrder), domains, axis, axisDomainOrder);
-   }
+                            const CArray<int,1>& axisDomainOrder)
+   {
+     std::vector<CScalar*> vecScalar;
+     return createGrid(generateId(domains, axis, vecScalar, axisDomainOrder), domains, axis, vecScalar, axisDomainOrder);
+   }
+
+   CGrid* CGrid::createGrid(const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
+                            const std::vector<CScalar*>& scalars, const CArray<int,1>& axisDomainOrder)
+   {
+     return createGrid(generateId(domains, axis, scalars, axisDomainOrder), domains, axis, scalars, axisDomainOrder);
+   }
+
+//   CGrid* CGrid::createGrid(StdString id, const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
+//                            const CArray<int,1>& axisDomainOrder)
+//   {
+//      if (axisDomainOrder.numElements() > 0 && axisDomainOrder.numElements() != (domains.size() + axis.size()))
+//        ERROR("CGrid* CGrid::createGrid(...)",
+//              << "The size of axisDomainOrder (" << axisDomainOrder.numElements()
+//              << ") is not coherent with the number of elements (" << domains.size() + axis.size() <<").");
+//
+//      CGrid* grid = CGridGroup::get("grid_definition")->createChild(id);
+//      grid->setDomainList(domains);
+//      grid->setAxisList(axis);
+//
+//      // By default, domains are always the first elements of a grid
+//      if (0 == axisDomainOrder.numElements())
+//      {
+//        int size = domains.size() + axis.size();
+//        grid->axis_domain_order.resize(size);
+//        for (int i = 0; i < size; ++i)
+//        {
+//          if (i < domains.size()) grid->axis_domain_order(i) = 2;
+//          else grid->axis_domain_order(i) = 1;
+//        }
+//      }
+//      else
+//      {
+//        grid->axis_domain_order.resize(axisDomainOrder.numElements());
+//        grid->axis_domain_order = axisDomainOrder;
+//      }
+//
+//      grid->solveDomainAxisRefInheritance(true);
+//
+//      return grid;
+//   }
 
    CGrid* CGrid::createGrid(StdString id, const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
-                            const CArray<bool,1>& axisDomainOrder)
-   {
-      if (axisDomainOrder.numElements() > 0 && axisDomainOrder.numElements() != (domains.size() + axis.size()))
+                            const std::vector<CScalar*>& scalars, const CArray<int,1>& axisDomainOrder)
+   {
+      if (axisDomainOrder.numElements() > 0 && axisDomainOrder.numElements() != (domains.size() + axis.size() + scalars.size()))
         ERROR("CGrid* CGrid::createGrid(...)",
               << "The size of axisDomainOrder (" << axisDomainOrder.numElements()
@@ -673,14 +752,24 @@
       grid->setDomainList(domains);
       grid->setAxisList(axis);
+      grid->setScalarList(scalars);
 
       // By default, domains are always the first elements of a grid
       if (0 == axisDomainOrder.numElements())
       {
-        int size = domains.size() + axis.size();
+        int size = domains.size() + axis.size() + scalars.size();
+        int nb = 0;
         grid->axis_domain_order.resize(size);
         for (int i = 0; i < size; ++i)
         {
-          if (i < domains.size()) grid->axis_domain_order(i) = true;
-          else grid->axis_domain_order(i) = false;
+          if (i < domains.size()) {
+            grid->axis_domain_order(i) = 2;
+
+          }
+          else if ((scalars.size() < (size-nb)) < size) {
+            grid->axis_domain_order(i) = 1;
+          }
+          else
+            grid->axis_domain_order(i) = 0;
+          ++nb;
         }
       }
@@ -698,6 +787,18 @@
    CGrid* CGrid::cloneGrid(const StdString& idNewGrid, CGrid* gridSrc)
    {
+     std::vector<CDomain*> domainSrcTmp = gridSrc->getDomains(), domainSrc;
      std::vector<CAxis*> axisSrcTmp = gridSrc->getAxis(), axisSrc;
-     std::vector<CDomain*> domainSrcTmp = gridSrc->getDomains(), domainSrc;
+     std::vector<CScalar*> scalarSrcTmp = gridSrc->getScalars(), scalarSrc;
+
+     for (int idx = 0; idx < domainSrcTmp.size(); ++idx)
+     {
+       CDomain* domain = CDomain::createDomain();
+       domain->duplicateAttributes(domainSrcTmp[idx]);
+       domain->duplicateTransformation(domainSrcTmp[idx]);
+       domain->solveRefInheritance(true);
+       domain->solveInheritanceTransformation();
+       domainSrc.push_back(domain);
+     }
+
      for (int idx = 0; idx < axisSrcTmp.size(); ++idx)
      {
@@ -710,15 +811,15 @@
      }
 
-     for (int idx = 0; idx < domainSrcTmp.size(); ++idx)
+     for (int idx = 0; idx < scalarSrcTmp.size(); ++idx)
      {
-       CDomain* domain = CDomain::createDomain();
-       domain->duplicateAttributes(domainSrcTmp[idx]);
-       domain->duplicateTransformation(domainSrcTmp[idx]);
-       domain->solveRefInheritance(true);
-       domain->solveInheritanceTransformation();
-       domainSrc.push_back(domain);
-     }
-
-      CGrid* grid = CGrid::createGrid(idNewGrid, domainSrc, axisSrc, gridSrc->axis_domain_order);
+       CScalar* scalar = CScalar::createScalar();
+       scalar->duplicateAttributes(scalarSrcTmp[idx]);
+       scalar->duplicateTransformation(scalarSrcTmp[idx]);
+       scalar->solveRefInheritance(true);
+       scalar->solveInheritanceTransformation();
+       scalarSrc.push_back(scalar);
+     }
+
+      CGrid* grid = CGrid::createGrid(idNewGrid, domainSrc, axisSrc, scalarSrc, gridSrc->axis_domain_order);
 
       return grid;
@@ -726,7 +827,7 @@
 
    StdString CGrid::generateId(const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
-                               const CArray<bool,1>& axisDomainOrder)
-   {
-      if (axisDomainOrder.numElements() > 0 && axisDomainOrder.numElements() != (domains.size() + axis.size()))
+                               const std::vector<CScalar*>& scalars, const CArray<int,1>& axisDomainOrder)
+   {
+      if (axisDomainOrder.numElements() > 0 && axisDomainOrder.numElements() != (domains.size() + axis.size() + scalars.size()))
         ERROR("CGrid* CGrid::generateId(...)",
               << "The size of axisDomainOrder (" << axisDomainOrder.numElements()
@@ -735,7 +836,8 @@
       std::ostringstream id;
 
-      if (domains.empty() && axis.empty())
-        id << "__scalar_grid__";
-      else
+      if (domains.empty() && axis.empty() && !scalars.empty())
+        id << "__scalar_";
+
+      if (0 != (domains.size() + axis.size() + scalars.size()))
       {
         id << "__grid";
@@ -745,14 +847,17 @@
           for (size_t i = 0; i < domains.size(); ++i) id << "_" << domains[i]->getId();
           for (size_t i = 0; i < axis.size(); ++i) id << "_" << axis[i]->getId();
+          for (size_t i = 0; i < scalars.size(); ++i) id << "_" << scalars[i]->getId();
         }
         else
         {
-          size_t iDomain = 0, iAxis = 0;
+          size_t iDomain = 0, iAxis = 0, iScalar = 0;
           for (size_t i = 0; i < axisDomainOrder.numElements(); ++i)
           {
-            if (axisDomainOrder(i))
+            if (2 == axisDomainOrder(i))
               id << "_" << domains[iDomain++]->getId();
+            else if (1 == axisDomainOrder(i))
+              id << "_" << axis[iAxis++]->getId();
             else
-              id << "_" << axis[iAxis++]->getId();
+              id << "_" << scalars[iScalar++]->getId();
           }
         }
@@ -785,4 +890,9 @@
    {
      return this->vAxisGroup_;
+   }
+
+   CScalarGroup* CGrid::getVirtualScalarGroup() const
+   {
+     return this->vScalarGroup_;
    }
 
@@ -1037,11 +1147,12 @@
   void CGrid::computeGridGlobalDimension(const std::vector<CDomain*>& domains,
                                          const std::vector<CAxis*>& axis,
-                                         const CArray<bool,1>& axisDomainOrder)
-  {
-    globalDim_.resize(domains.size()*2+axis.size());
-    int idx = 0, idxDomain = 0, idxAxis = 0;
+                                         const std::vector<CScalar*>& scalars,
+                                         const CArray<int,1>& axisDomainOrder)
+  {
+    globalDim_.resize(domains.size()*2+axis.size()+scalars.size());
+    int idx = 0, idxDomain = 0, idxAxis = 0, idxScalar = 0;
     for (int i = 0; i < axisDomainOrder.numElements(); ++i)
     {
-      if (axisDomainOrder(i))
+      if (2 == axisDomainOrder(i))
       {
         if (!(domains[idxDomain]->type.isEmpty()) && (domains[idxDomain]->type==CDomain::type_attr::unstructured))
@@ -1060,8 +1171,14 @@
         idx += 2;
       }
-      else
+      else if (1 == axisDomainOrder(i))
       {
         globalDim_[idx] = axis[idxAxis]->n_glo.getValue();
         ++idxAxis;
+        ++idx;
+      }
+      else
+      {
+        globalDim_[idx] = 1;
+        ++idxScalar;
         ++idx;
       }
@@ -1179,5 +1296,5 @@
         {
           indexMap[i] = idx;
-          if (true == axis_domain_order(i))
+          if (2 == axis_domain_order(i))
           {
             ++ssize;
@@ -1188,5 +1305,5 @@
         }
 
-        int axisId = 0, domainId = 0;
+        int axisId = 0, domainId = 0, scalarId = 0;
         std::vector<CDomain*> domainList = getDomains();
         std::vector<CAxis*> axisList = getAxis();
@@ -1194,5 +1311,5 @@
         for (int i = 0; i < numElement; ++i)
         {
-          if (axis_domain_order(i))
+          if (2 == axis_domain_order(i)) //domain
           {
             nZoomBegin[indexMap[i]] = domainList[domainId]->zoom_ibegin_srv;
@@ -1207,5 +1324,5 @@
             ++domainId;
           }
-          else
+          else if (1 == axis_domain_order(i)) // axis
           {
             nZoomBegin[indexMap[i]] = axisList[axisId]->zoom_begin_srv;
@@ -1214,4 +1331,12 @@
             nGlob[indexMap[i]] = axisList[axisId]->n_glo;
             ++axisId;
+          }
+          else // scalar
+          {
+            nZoomBegin[indexMap[i]] = 0;
+            nZoomSize[indexMap[i]]  = 1;
+            nZoomBeginGlobal[indexMap[i]] = 0;
+            nGlob[indexMap[i]] = 1;
+            ++scalarId;
           }
         }
@@ -1281,4 +1406,9 @@
            return true;
            break;
+
+         case EVENT_ID_ADD_SCALAR :
+           recvAddScalar(event);
+           return true;
+           break;
         default :
           ERROR("bool CDomain::dispatchEvent(CEventServer& event)",
@@ -1293,5 +1423,5 @@
    CDomain* CGrid::addDomain(const std::string& id)
    {
-     order_.push_back(true);
+     order_.push_back(2);
      axis_domain_order.resize(order_.size());
      for (int idx = 0; idx < order_.size(); ++idx) axis_domain_order(idx)=order_[idx];
@@ -1301,5 +1431,5 @@
    CAxis* CGrid::addAxis(const std::string& id)
    {
-     order_.push_back(false);
+     order_.push_back(1);
      axis_domain_order.resize(order_.size());
      for (int idx = 0; idx < order_.size(); ++idx) axis_domain_order(idx)=order_[idx];
@@ -1307,4 +1437,12 @@
    }
 
+   CScalar* CGrid::addScalar(const std::string& id)
+   {
+     order_.push_back(0);
+     axis_domain_order.resize(order_.size());
+     for (int idx = 0; idx < order_.size(); ++idx) axis_domain_order(idx)=order_[idx];
+     return vScalarGroup_->createChild(id);
+   }
+
    //! Change virtual field group to a new one
    void CGrid::setVirtualDomainGroup(CDomainGroup* newVDomainGroup)
@@ -1317,4 +1455,10 @@
    {
       this->vAxisGroup_ = newVAxisGroup;
+   }
+
+   //! Change virtual variable group to new one
+   void CGrid::setVirtualScalarGroup(CScalarGroup* newVScalarGroup)
+   {
+      this->vScalarGroup_ = newVScalarGroup;
    }
 
@@ -1330,4 +1474,10 @@
    {
       this->setVirtualAxisGroup(CAxisGroup::create());
+   }
+
+   //! Create virtual variable group, which is done normally on initializing file
+   void CGrid::setVirtualScalarGroup(void)
+   {
+      this->setVirtualScalarGroup(CScalarGroup::create());
    }
 
@@ -1387,4 +1537,31 @@
 
    /*!
+   \brief Send a message to create a scalar on server side
+   \param[in] id String identity of scalar that will be created on server
+   */
+   void CGrid::sendAddScalar(const string& id)
+   {
+    CContext* context=CContext::getCurrent();
+
+    if (! context->hasServer )
+    {
+       CContextClient* client=context->client;
+
+       CEventClient event(this->getType(),EVENT_ID_ADD_SCALAR);
+       if (client->isServerLeader())
+       {
+         CMessage msg;
+         msg<<this->getId();
+         msg<<id;
+         const std::list<int>& ranks = client->getRanksServerLeader();
+         for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+           event.push(*itRank,1,msg);
+         client->sendEvent(event);
+       }
+       else client->sendEvent(event);
+    }
+   }
+
+   /*!
    \brief Receive a message annoucing the creation of a domain on server side
    \param[in] event Received event
@@ -1432,4 +1609,28 @@
       buffer >> id;
       addAxis(id);
+   }
+
+   /*!
+   \brief Receive a message annoucing the creation of an scalar on server side
+   \param[in] event Received event
+   */
+   void CGrid::recvAddScalar(CEventServer& event)
+   {
+
+      CBufferIn* buffer = event.subEvents.begin()->buffer;
+      string id;
+      *buffer >> id;
+      get(id)->recvAddScalar(*buffer);
+   }
+
+   /*!
+   \brief Receive a message annoucing the creation of an scalar on server side
+   \param[in] buffer Buffer containing message
+   */
+   void CGrid::recvAddScalar(CBufferIn& buffer)
+   {
+      string id;
+      buffer >> id;
+      addScalar(id);
    }
 
@@ -1468,4 +1669,16 @@
       }
     }
+
+    setScalarList();
+    it = scalarList_.begin(); itE = scalarList_.end();
+    for (; it != itE; ++it)
+    {
+      CScalar* pScalar = CScalar::get(*it);
+      if (context->hasClient)
+      {
+        pScalar->solveRefInheritance(apply);
+        pScalar->solveInheritanceTransformation();
+      }
+    }
   }
 
@@ -1513,10 +1726,10 @@
       else
       {
-        int ssize = axis_domain_order.numElements();
-        for (int i = 0; i < ssize; ++i)
-          if (axis_domain_order(i) != (transformGridSrc->axis_domain_order)(i))
-            ERROR("CGrid::completeGrid(CGrid* transformGridSrc)",
-                  << "Grids " << this->getId() << " and " << transformGridSrc->getId()
-                  << " don't have elements in the same order");
+//        int ssize = axis_domain_order.numElements();
+//        for (int i = 0; i < ssize; ++i)
+//          if (axis_domain_order(i) != (transformGridSrc->axis_domain_order)(i))
+//            ERROR("CGrid::completeGrid(CGrid* transformGridSrc)",
+//                  << "Grids " << this->getId() << " and " << transformGridSrc->getId()
+//                  << " don't have elements in the same order");
       }
     }
@@ -1543,10 +1756,10 @@
     else
     {
-      int ssize = axis_domain_order.numElements();
-      for (int i = 0; i < ssize; ++i)
-        if (axis_domain_order(i) != (transformGridSrc->axis_domain_order)(i))
-          ERROR("CGrid::transformGrid(CGrid* transformGridSrc)",
-                << "Grids " << this->getId() << " and " << transformGridSrc->getId()
-                << " don't have elements in the same order");
+//      int ssize = axis_domain_order.numElements();
+//      for (int i = 0; i < ssize; ++i)
+//        if (axis_domain_order(i) != (transformGridSrc->axis_domain_order)(i))
+//          ERROR("CGrid::transformGrid(CGrid* transformGridSrc)",
+//                << "Grids " << this->getId() << " and " << transformGridSrc->getId()
+//                << " don't have elements in the same order");
     }
 
@@ -1592,4 +1805,17 @@
 
   /*!
+  \brief Get the list of  axis pointers
+  \return list of axis pointers
+  */
+  std::vector<CScalar*> CGrid::getScalars()
+  {
+    std::vector<CScalar*> sList;
+    if (!scalarList_.empty())
+      for (int i =0; i < scalarList_.size(); ++i) sList.push_back(CScalar::get(scalarList_[i]));
+
+    return sList;
+  }
+
+  /*!
   \brief Set domain(s) of a grid from a list
   \param[in] domains list of domains
@@ -1647,4 +1873,31 @@
 
   /*!
+  \brief Set scalar(s) of a grid from a list
+  \param[in] scalars list of scalars
+  */
+  void CGrid::setScalarList(const std::vector<CScalar*> scalars)
+  {
+    if (isScalarListSet) return;
+    std::vector<CScalar*> sList = this->getVirtualScalarGroup()->getAllChildren();
+    if (!scalars.empty() && sList.empty())
+    {
+      for (int i = 0; i < scalars.size(); ++i)
+        this->getVirtualScalarGroup()->addChild(scalars[i]);
+      sList = this->getVirtualScalarGroup()->getAllChildren();
+    }
+
+    if (!sList.empty())
+    {
+      int sizeScalar = sList.size();
+      scalarList_.resize(sizeScalar);
+      for (int i = 0; i < sizeScalar; ++i)
+      {
+        scalarList_[i] = sList[i]->getId();
+      }
+      isScalarListSet = true;
+    }
+  }
+
+  /*!
   \brief Get list of id of domains
   \return id list of domains
@@ -1666,4 +1919,17 @@
   }
 
+  /*!
+  \brief Get list of id of scalar
+  \return id list of scalar
+  */
+  std::vector<StdString> CGrid::getScalarList()
+  {
+    setScalarList();
+    return scalarList_;
+  }
+
+  /*!
+    Send all attributes of domains from client to server
+  */
   void CGrid::sendAllDomains()
   {
@@ -1677,4 +1943,7 @@
   }
 
+  /*!
+    Send all attributes of axis from client to server
+  */
   void CGrid::sendAllAxis()
   {
@@ -1689,4 +1958,22 @@
   }
 
+  /*!
+    Send all attributes of scalars from client to server
+  */
+  void CGrid::sendAllScalars()
+  {
+    std::vector<CScalar*> sList = this->getVirtualScalarGroup()->getAllChildren();
+    int sSize = sList.size();
+
+    for (int i = 0; i < sSize; ++i)
+    {
+      sendAddScalar(sList[i]->getId());
+      sList[i]->sendAllAttributesToServer();
+    }
+  }
+
+  /*!
+    Parse a grid, for now, it contains only domain, axis and scalar
+  */
   void CGrid::parse(xml::CXMLNode& node)
   {
@@ -1697,13 +1984,18 @@
       StdString domainName("domain");
       StdString axisName("axis");
+      StdString scalarName("scalar");
       do
       {
         if (node.getElementName() == domainName) {
-          order_.push_back(true);
+          order_.push_back(2);
           this->getVirtualDomainGroup()->parseChild(node);
         }
         if (node.getElementName() == axisName) {
-          order_.push_back(false);
+          order_.push_back(1);
           this->getVirtualAxisGroup()->parseChild(node);
+        }
+        if (node.getElementName() == scalarName) {
+          order_.push_back(0);
+          this->getVirtualScalarGroup()->parseChild(node);
         }
       } while (node.goToNextElement());
@@ -1723,4 +2015,5 @@
     setDomainList();
     setAxisList();
+    setScalarList();
    }
 } // namespace xios
Index: /XIOS/trunk/src/node/grid.hpp
===================================================================
--- /XIOS/trunk/src/node/grid.hpp	(revision 886)
+++ /XIOS/trunk/src/node/grid.hpp	(revision 887)
@@ -9,4 +9,5 @@
 #include "domain.hpp"
 #include "axis.hpp"
+#include "scalar.hpp"
 #include "array_new.hpp"
 #include "attribute_array.hpp"
@@ -24,4 +25,5 @@
    class CDomainGroup;
    class CAxisGroup;
+   class CScalarGroup;
    class CGrid;
    class CDistributionClient;
@@ -55,10 +57,5 @@
          enum EEventId
          {
-           EVENT_ID_INDEX, EVENT_ID_ADD_DOMAIN, EVENT_ID_ADD_AXIS
-         };
-
-         enum EElementType
-         {
-           GRID_ONLY_AXIS, GRID_ONLY_DOMAIN, GRID_AXIS_DOMAIN
+           EVENT_ID_INDEX, EVENT_ID_ADD_DOMAIN, EVENT_ID_ADD_AXIS, EVENT_ID_ADD_SCALAR
          };
 
@@ -122,9 +119,15 @@
          static CGrid* createGrid(CDomain* domain, CAxis* axis);
          static CGrid* createGrid(const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
-                                  const CArray<bool,1>& axisDomainOrder = CArray<bool,1>());
+                                  const CArray<int,1>& axisDomainOrder = CArray<int,1>());
+//         static CGrid* createGrid(StdString id, const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
+//                                  const CArray<int,1>& axisDomainOrder = CArray<int,1>());
          static CGrid* createGrid(StdString id, const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
-                                  const CArray<bool,1>& axisDomainOrder = CArray<bool,1>());
+                                  const std::vector<CScalar*>& scalars, const CArray<int,1>& axisDomainOrder = CArray<int,1>());
+         static CGrid* createGrid(const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
+                                  const std::vector<CScalar*>& scalars, const CArray<int,1>& axisDomainOrder);
+//         static StdString generateId(const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
+//                                     const std::vector<CScalar*>& scalars, const CArray<int,1>& axisDomainOrder = CArray<int,1>());
          static StdString generateId(const std::vector<CDomain*>& domains, const std::vector<CAxis*>& axis,
-                                     const CArray<bool,1>& axisDomainOrder = CArray<bool,1>());
+                                     const std::vector<CScalar*>& scalars, const CArray<int,1>& axisDomainOrder = CArray<int,1>());
          static StdString generateId(const CGrid* gridSrc, const CGrid* gridDest);
          static CGrid* cloneGrid(const StdString& idNewGrid, CGrid* gridSrc);
@@ -144,4 +147,5 @@
          void solveDomainRef(bool checkAtt);
          void solveAxisRef(bool checkAtt);
+         void solveScalarRef(bool checkAtt);
          void solveDomainAxisRefInheritance(bool apply = true);
          void solveTransformations();
@@ -150,8 +154,11 @@
          CDomain* addDomain(const std::string& id=StdString());
          CAxis* addAxis(const std::string& id=StdString());
+         CScalar* addScalar(const std::string& id=StdString());
          void sendAddDomain(const std::string& id="");
          void sendAddAxis(const std::string& id="");
+         void sendAddScalar(const std::string& id="");
          void sendAllDomains();
          void sendAllAxis();
+         void sendAllScalars();
 
          static void recvAddDomain(CEventServer& event);
@@ -159,4 +166,6 @@
          static void recvAddAxis(CEventServer& event);
          void recvAddAxis(CBufferIn& buffer);
+         static void recvAddScalar(CEventServer& event);
+         void recvAddScalar(CBufferIn& buffer);
 
          static bool dispatchEvent(CEventServer& event);
@@ -172,6 +181,8 @@
          std::vector<StdString> getDomainList();
          std::vector<StdString> getAxisList();
+         std::vector<StdString> getScalarList();
          std::vector<CDomain*> getDomains();
          std::vector<CAxis*> getAxis();
+         std::vector<CScalar*> getScalars();
          std::vector<int> getAxisOrder();
          std::vector<int> getGlobalDimension();
@@ -218,5 +229,6 @@
          void computeGridGlobalDimension(const std::vector<CDomain*>& domains,
                                          const std::vector<CAxis*>& axis,
-                                         const CArray<bool,1>& axisDomainOrder);
+                                         const std::vector<CScalar*>& scalars,
+                                         const CArray<int,1>& axisDomainOrder);
 
       private:
@@ -225,5 +237,5 @@
                           const std::vector<CArray<bool,1>* >& domainMasks,
                           const std::vector<CArray<bool,1>* >& axisMasks,
-                          const CArray<bool,1>& axisDomainOrder,
+                          const CArray<int,1>& axisDomainOrder,
                           bool createMask = false);
         template<int N>
@@ -234,10 +246,14 @@
         void setVirtualAxisGroup(CAxisGroup* newVAxisGroup);
         void setVirtualAxisGroup();
-
+        void setVirtualScalarGroup(CScalarGroup* newVScalarGroup);
+        void setVirtualScalarGroup();
+
+        void setDomainList(const std::vector<CDomain*> domains = std::vector<CDomain*>());
         void setAxisList(const std::vector<CAxis*> axis = std::vector<CAxis*>());
-        void setDomainList(const std::vector<CDomain*> domains = std::vector<CDomain*>());
-
+        void setScalarList(const std::vector<CScalar*> scalars = std::vector<CScalar*>());
+
+        CDomainGroup* getVirtualDomainGroup() const;
         CAxisGroup* getVirtualAxisGroup() const;
-        CDomainGroup* getVirtualDomainGroup() const;
+        CScalarGroup* getVirtualScalarGroup() const;
 
         void checkAttributesAfterTransformation();
@@ -246,10 +262,10 @@
                                    CClientServerMapping::GlobalIndexMap& globalIndexOnServer);
 
-
       private:
         CDomainGroup* vDomainGroup_;
         CAxisGroup* vAxisGroup_;
-        std::vector<std::string> axisList_, domList_;
-        bool isAxisListSet, isDomListSet;
+        CScalarGroup* vScalarGroup_;
+        std::vector<std::string> axisList_, domList_, scalarList_;
+        bool isAxisListSet, isDomListSet, isScalarListSet;
 
         CDistributionClient* clientDistribution_;
@@ -275,5 +291,5 @@
         CClientServerMapping::GlobalIndexMap globalIndexOnServer_;
             // List order of axis and domain in a grid, if there is a domain, it will take value 1 (true), axis 0 (false)
-        std::vector<bool> order_;
+        std::vector<int> order_;
    }; // class CGrid
 
@@ -306,5 +322,5 @@
                              const std::vector<CArray<bool,1>* >& domainMasks,
                              const std::vector<CArray<bool,1>* >& axisMasks,
-                             const CArray<bool,1>& axisDomainOrder,
+                             const CArray<int,1>& axisDomainOrder,
                              bool createMask)
    {
@@ -320,13 +336,14 @@
     {
       indexMap[i] = idx;
-      if (true == axisDomainOrder(i)) {
+      if (2 == axisDomainOrder(i)) {
           eachDimSize[indexMap[i]]   = domainP[idxDomain]->ni;
           eachDimSize[indexMap[i]+1] = domainP[idxDomain]->nj;
           idx += 2; ++idxDomain;
       }
-      else {
+      else if (1 == axisDomainOrder(i)) {
         eachDimSize[indexMap[i]] = axisMasks[idxAxis]->numElements();
         ++idx; ++idxAxis;
       }
+      else ++idx;
     }
 
@@ -365,10 +382,10 @@
       for (int i = 0; i < numElement; ++i)
       {
-        if (axisDomainOrder(i))
+        if (2 == axisDomainOrder(i))
         {
           maskValue = maskValue && (*domainMasks[idxDomain])(idxLoop[indexMap[i]] + idxLoop[indexMap[i]+1] * eachDimSize[indexMap[i]]);
           ++idxDomain;
         }
-        else
+        else if (1 == axisDomainOrder(i))
         {
           maskValue = maskValue && (*axisMasks[idxAxis])(idxLoop[indexMap[i]]);
